////////////////////////////////////////////////////////////
//
// Module SEM.CPP
//
// ASPI class library
// Semaphore support
//
// Project: A Programmer's Guide to SCSI
//
// Copyright (C) 1997, Brian Sawert
// Portions copyright (C) 1995, Larry Martin
// All rights reserved
//
////////////////////////////////////////////////////////////


#include "sem.hpp"


MutexSemaphore::MutexSemaphore()
   {
   Handle = CreateMutex(NULL,FALSE,NULL);
   // Not much to do on failure
   }

MutexSemaphore::~MutexSemaphore()
   {
   if (Handle)
      CloseHandle(Handle);
   }

int MutexSemaphore::RequestMutex(long timeout)
   {
   int x = WaitForSingleObject(Handle,(timeout == -1) ? INFINITE : timeout);
   switch (x)
      {
      case WAIT_OBJECT_0:
      case WAIT_ABANDONED:
         return 0;
      default:
         return -1;
      }
   }


int MutexSemaphore::ReleaseMutex()
   {
   return (::ReleaseMutex(Handle) == TRUE) ? 0 : -1;
   }
