
;---------------------------------------------------------------------------
; DOSDRVR.INC	
;
; This file contains various structures and equates commonly used in
; MS-DOS device drivers
;
;---------------------------------------------------------------------------


RequestHeader	struc
	rhLength	db ?
	rhUnit		db ?
	rhCommandCode	db ?
	rhStatus	dw ?
	rhReserved	db 8 dup (?)
RequestHeader	ends

$RequestHeaderSize	equ	13

InitPacket		struc
	iHeader		db $RequestHeaderSize dup (?)
	iData1		db ?
	iPtr1		dd ?
	iPtr2		dd ?
	iData2		db ?
	iMessageFlag	dw ?	; for DOS5+
InitPacket	ends

ReadWritePacket		struc
	rwHeader	db $RequestHeaderSize dup (?)
	rwMediaDesc	db ?
	rwAddress	dd ?
	rwCount		dw ?
	rwSector	dw ?		; if 0FFFFh, use rwHugeSector
	rwVolumeId	dd ?
	rwHugeSector	dd ?
ReadWritePacket		ends

NdReadNoWaitPacket	struc
	nrHeader	db $RequestHeaderSize dup (?)
	ndReturnChar	db ?
NdReadNoWaitPacket	ends

OpenClosePacket		struc
	ocHeader	db $RequestHeaderSize dup (?)
OpenClosePacket		ends

GenericIoctlPacket	struc
	giHeader	db $RequestHeaderSize dup (?)
	giCategory	db ?
	giCode		db ?
	giReserved	dd ?
	giParmBuffer	dd ?	; I call it a parameter buffer
	giFileNumber	dw ?
GenericIoctlPacket	ends



; Bit flags for 'rhStatus'
$sysflag_done			equ	0100h
$sysflag_busy			equ	0200h
$sysflag_system_error		equ	8000h

; Error codes for system errors (low byte of 'rhStatus')
$syserr_write_protected		equ	0
$syserr_unknown_unit		equ	1
$syserr_not_ready		equ	2
$syserr_unknown_command		equ	3
$syserr_crc			equ	4
$syserr_bad_length		equ	5
$syserr_seek			equ	6
$syserr_unknown_media		equ	7
$syserr_sector_not_found	equ	8
$syserr_no_paper		equ	9
$syserr_write_fault		equ	10
$syserr_read_fault		equ	11
$syserr_general_failure		equ	12
$syserr_13			equ	13
$syserr_14			equ	14
$syserr_disk_change		equ	15

; Command codes for request packes
$syscmd_init			equ	00h
$syscmd_media_check		equ	01h
$syscmd_build_bpb		equ	02h
$syscmd_ioctl_read		equ	03h
$syscmd_read			equ	04h
$syscmd_nd_read_no_wait		equ	05h
$syscmd_input_status		equ	06h
$syscmd_input_flush		equ	07h
$syscmd_write			equ	08h
$syscmd_write_verify		equ	09h
$syscmd_output_status		equ	0Ah
$syscmd_output_flush		equ	0Bh
$syscmd_ioctl_write		equ	0Ch
$syscmd_open			equ	0Dh
$syscmd_close			equ	0Eh
$syscmd_removable_media		equ	0Fh
$syscmd_generic_ioctl		equ	13h
$syscmd_get_logical_device	equ	17h
$syscmd_set_logical_drive_map	equ	18h
$syscmd_ioctl_query		equ	19h
; Last valid command code
$syscmd_max			equ	19h


