/***************************************************************************
 *                                                                         *
 *  Copyright 1995 Symbios Logic Incorporated.  All rights reserved.       *
 *                                                                         *
 *  This file is confidential and a trade secret of Symbios Logic.  The    *
 *  receipt of or possession of this file does not convey any rights to    *
 *  reproduce or disclose its contents or to manufacture, use, or sell     *
 *  anything it may describe, in whole, or in part, without the specific   *
 *  written consent of Symbios Logic Incorporated.                         *
 *                                                                         *
 ***************************************************************************/

/*           Name:  TEST.H
 *          Title:  Validation test code test.c header
 *      $Workfile:  $
 *      $Revision:  $
 *       $Modtime:  $
 *     Programmer:  (Put your name here)
 *  Creation Date:  (Put date here)
 *
 *  Version History
 *  ---------------
 *
 *    Date    Who?  Description
 *  --------  ----  -------------------------------------------------------
#BeginRevision
 *  MM/DD/YY  XXX   Initial Revision.
#EndRevision
 *
#BeginDescription
 *
 *  This file contains structures and #defines used by the TEST.C source
 *  file.
 *
#EndDescription
 *
 *-------------------------------------------------------------------------
 *
 *  $Header: $
 *
 */

#include "valtypes.h"

/* Name of test */
#define TEST_NAME "Skeleton"
/* Version of test */
#define TEST_VERSION "1.00.00"
/* Device or devices under test */
#define DEVICE_UNDER_TEST "53C8XX"

typedef struct {
	VINT all;                /* enable all tests all variations */
	VINT device;             /* run tests on device n, DO NOT REMOVE THIS */
	VINT testnum;            /* indicates a specific test number to run */
	VINT lowtest;            /* indicates the low test in a range to run, -1 if not spec */
	VINT hightest;           /* indicates the high test in a range to run, -1 if not spec */
	VINT verbose;            /* set if user wants output to go to the screen */
									 /* DO NOT REMOVE THE VERBOSE VARIABLE */
	VINT printti;            /* print test info/help */
	VINT param_sub;          /* set if user wants to runs a subset of the test parameters */
	VINT ud_flag1;           /* name this flag */
	VINT ud_flag2;           /* name this flag */
	VINT ud_flag3;           /* name this flag */
} cmdlineflags;

/* function prototypes */
extern void ParseCmdLine(cmdlineflags *flags, VINT argc, VCHAR **argv);
extern VINT test(pcidev_record *PCIDevice, cmdlineflags *flags);

/* global ptr for the log file name */
/* didn't really want to do this but to make the WriteLog function work */
/* anywhere without having to pass the flags structure everywhere is was */
/* necessary, this is the only global passed from one file to another */
extern VCHAR *logfilename_ptr;


